#!/usr/bin/perl
#
# ip-up.pl
# This script is called to modify the /etc/ppp/ip-up script. It takes
# command line flag -a or -d. -a adds a call to ipchange.pl to ip-up.
# -d removes it. It preserves the call to ifup-post in ip-up. If the
# lines are commented out in ifup-post, this will cause problems.
# The ifup-post script should not be manually edited.
#
# (C) 2001 Rebel.com

use nameshash;
use Getopt::Std;

getopts ('ad');

my $file = "$PPP_CONF_DIR/ip-up";
my ($line, $temp, @data);
chown 0,0,"$file";
chmod 0755,"$file";
	

open FH, "< $file" or die "Can't open $file, $!.\n";
@data = <FH>;
close FH;

open OUT, "> $file~" or die "Can't open $file~, $!.\n";

if ($opt_a) {
	add_ip();
} elsif ($opt_d) {
	delete_ip();
} else {
	print "Usage: $0 -a|-d\n";
	print "\t -a adds the line to call ipchange.pl to /etc/ppp/ip-up\n";
	print "\t if necessary.\n";
	print "\t -d deletes the call to ipchange.pl from /etc/ppp/ip-up.\n";
}

sub delete_ip {

	my $data;

	foreach (@data) {
		$data .= $_;
	}

	$data =~ s/if\s+\[\s+"\$LOGDEVICE" == "" \]; then(.*?)^fi/\/etc\/sysconfig\/network-scripts\/ifup-post ifcfg-\${LOGDEVICE}/ms;
	$data =~ s/chmod 644 \/etc\/named.conf\n//;
	$data =~ s/chown 0,0 \/etc\/named.conf\n//;

	print OUT "$data";
	close OUT;
	rename "$file~", "$file";
	chown 0,0,"$file";
	chmod 0755, "$file";

} # delete_ip

sub add_ip {

	if (! grep (/ipchange.pl.*REALDEVICE/, @data)) {
		foreach $line (@data) {
			if ($line =~ /(^.*ifup-post.*$)/) {
				$temp = $1;
				$line = qq{if [ "\$LOGDEVICE" == "" ]; then
	echo "ip-up: calling ipchange.pl $REALDEVICE" >> \/etc\/httpd\/logs/error_log
	\/var\/www\/html\/netwinder\/plugins\/os-dyndns\/ipchange.pl \$REALDEVICE 
else 
	$temp 
fi\n};
			}
			if($line =~ /(^.*: last line.*$)/ ){
				$line =~ s/:/chmod 644 \/etc\/named.conf\nchown 0,0 \/etc\/named.conf\n:/;
			}
			print OUT $line;
		}
		close OUT;
		rename "$file~", "$file";
		chown 0,0,"$file";
		chmod 0755, "$file";
	}
} # add_ip
